<template>
  <!-- ForgotPassword Form -->
  <form id="forgot-password-form" class="w-full">

    <!-- Error messages -->
    <t-alert v-if="form.globalError" variant="error" class="mb-8" show>
      <p class="text-error">{{ form.globalError }}</p>
    </t-alert>

    <!-- Email -->
    <Input
      v-model="emailValue"
      name="email"
      :variant="emailState ? 'primary' : 'error'"
      :state="emailState"
      :label="$h.capitalize($t('user.email'))"
      :placeholder="$h.capitalize($t('user.email'))"
      :error="getFieldErrorMessage('email')"
      fluid
    />

    <!-- Password -->
    <InputPassword
      v-model="passwordValue"
      name="password"
      :variant="passwordState ? 'primary' : 'error'"
      :state="passwordState"
      :placeholder="$h.capitalize($t('user.newPassword'))"
      :label="$h.capitalize($t('user.newPassword'))"
      :description="$t('user.passwordPolicyDescription')"
      :error="getFieldErrorMessage('password')"
      fluid
    />

    <!-- Confirm password -->
    <InputPassword
      v-model="confirmPasswordValue"
      name="confirmPassword"
      :variant="confirmPasswordState ? 'primary' : 'error'"
      :state="confirmPasswordState"
      :label="$h.capitalize($t('user.confirmPassword'))"
      :placeholder="$h.capitalize($t('user.confirmPassword'))"
      fluid
      class="mb-4"
    />

    <!-- Confirm button -->
    <Button
      variant="action"
      :disabled="!isFormValid"
      @click.native="handleOk"
      fluid
    >
      {{ $t('global.confirm') | capitalize }}
    </Button>

  </form>
</template>

<script>
// vuex helpers
import { mapActions } from 'vuex'
// BaseForm
import BaseForm from '@/components/commons/form/BaseForm'
// utils
import { validateEmail } from '#utils'

/**
 * ForgotPasswordForm component
 */
export default {
  name: 'ForgotPasswordForm',
  extends: BaseForm,
  props: {
    /**
     * Token for reset password
     */
    token: {
      type: String
    }
  },
  // 'form' option (see src/components/commons/form/BaseForm)
  form: {
    fields: {
      /**
       * email
       */
      email: {
        // Default: generate 'emailValue' & 'emailChanged'
        default: function () {
          return ''
        },
        // Generate: 'emailState'
        state: function () {
          return !this.isFieldInError('email') // No errors ?
            ? this.emailValue.length > 0 // Filled ?
              ? this.isEmailValid // Valid ?
              : true
            : false // else -> errors
        },
        // Generate: 'isEmailValid'
        isValid: function () {
          return validateEmail(this.emailValue)
        }
      },
      /**
       * password
       */
      password: {
        // Default: generate 'passwordValue' & 'passwordChanged'
        default: function () {
          return ''
        },
        // Generate: 'passwordState'
        state: function () {
          return !this.isFieldInError('password') // No errors ?
            ? this.passwordValue.length > 0 // Filled ?
              ? this.isPasswordValid // Valid ?
              : true
            : false // else -> errors
        },
        // Generate: 'isPasswordValid'
        isValid: function () {
          return this.$root.auth.doesPasswordMatchPolicy(this.passwordValue)
        }
      },
      /**
       * confirmPassword
       */
      confirmPassword: {
        // Default: generate 'confirmPasswordValue' & 'confirmPasswordChangedChanged'
        default: function () {
          return ''
        },
        // Generate: 'confirmPasswordState'
        state: function () {
          return !this.isFieldInError('confirmPassword') // No errors ?
            ? this.confirmPasswordValue.length > 0 // Filled ?
              ? this.isConfirmPasswordValid // Valid ?
              : true
            : false // else -> errors
        },
        // Generate: 'isConfirmPasswordValid'
        isValid: function () {
          return this.$root.auth.doesPasswordMatchPolicy(this.confirmPasswordValue) &&
            this.passwordValue === this.confirmPasswordValue
        }
      }
    }
  },
  methods: {
    // Map actions from 'Users' store module
    ...mapActions('Users', [
      'resetPassword'
    ]),
    /**
     * Handle click on 'confirm' submit button.
     *
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    async handleOk (evt) {
      // Prevent click
      evt.preventDefault()
      // Reset errors before
      this.resetErrors()
      // Wait for resetPassword function
      const resetPasswordResponse = await this.resetPassword({
        token: this.token,
        email: this.emailValue,
        password: this.passwordValue,
        password_confirmation: this.confirmPasswordValue
      })
      // If passed
      if (!(resetPasswordResponse instanceof Error)) {
        // Emit 'password-changed' event
        this.$emit('password-changed')
      // Else parse server error
      } else {
        this.setFormErrors(resetPasswordResponse) // Set form errors from response
      }
    }
  }
}
</script>
